unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, math, FPimage, FileUtil, Forms,
  Controls, Graphics, Dialogs, IntfGraphics, LCLType;

type

  { TForm1 }

  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    FPicture: TPicture;
    FBitmap: TBitmap;
    FFadeArray: Array of Array of Word;
    Cnt: QWord;
    Runs: Integer;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  DoubleBuffered := True;
  FPicture := TPicture.Create;
  FPicture.LoadFromFile('test.jpg');
  FBitmap := TBitmap.Create;
  Cnt := 0;
  Runs := 0;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FBitmap.Free;
  FPicture.Free;
end;

procedure TForm1.FormMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  Repaint;
end;

procedure TForm1.FormPaint(Sender: TObject);
var
  IntfImg: TLazIntfImage;
  ImgHandle, ImgMaskHandle: HBITMAP;
  px, py: Integer;
  CurColor: TFPColor;
  TempBitmap: TBitmap;
  mp: TPoint;
begin
  mp := Mouse.CursorPos;
  mp := ScreenToClient(mp);
  mp.x := mp.x - Length(FFadeArray) div 2;
  mp.y := mp.y - Length(FFadeArray) div 2;

  Cnt := Cnt - GetTickCount64;

  IntfImg := TLazIntfImage.Create(0, 0);
  IntfImg.LoadFromBitmap(FBitmap.Handle, FBitmap.MaskHandle);
  TempBitmap := TBitmap.Create;

  for py := 0 to IntfImg.Height - 1 do
    for px := 0 to IntfImg.Width - 1 do begin
      if (px >= mp.x) and (px <= mp.x + High(FFadeArray)) and
         (py >= mp.y) and (py <= mp.y + High(FFadeArray)) then
      begin
        CurColor := IntfImg.Colors[px, py];
//        CurColor.red   := Min(CurColor.red   + FFadeArray[px - mp.x, py - mp.y], $FFFF);
//        CurColor.green := Min(CurColor.green + FFadeArray[px - mp.x, py - mp.y], $FFFF);
//        CurColor.blue  := Min(CurColor.blue  + FFadeArray[px - mp.x, py - mp.y], $FFFF);
        CurColor.red   := Max(CurColor.red   - FFadeArray[px - mp.x, py - mp.y], 0);
        CurColor.green := Max(CurColor.green - FFadeArray[px - mp.x, py - mp.y], 0);
        CurColor.blue  := Max(CurColor.blue  - FFadeArray[px - mp.x, py - mp.y], 0);
        IntfImg.Colors[px, py] := CurColor;
      end;
    end;
  IntfImg.CreateBitmaps(ImgHandle, ImgMaskHandle, False);
  TempBitmap.Handle := ImgHandle;
  TempBitmap.MaskHandle := ImgMaskHandle;
  Canvas.Draw(0, 0, TempBitmap);
  TempBitmap.Free;
  IntfImg.Free;

  Cnt := Cnt + GetTickCount64;
  Inc(Runs);

  Caption := IntToStr(Cnt div Runs)
end;

procedure TForm1.FormResize(Sender: TObject);
var
  x, y: Integer;
  aSize: Integer;
  i: Integer;
begin
  aSize := Min(ClientWidth, ClientHeight);
  SetLength(FFadeArray, aSize);
  for y := 0 to aSize - 1 do begin
    SetLength(FFadeArray[y], aSize);
    for x := 0 to aSize - 1 do begin
      i := Round((Sin(y / aSize * Pi) * Sin(x / aSize * Pi)) * 255) shl 8;
      FFadeArray[y, x] := i;
    end;
  end;

  FBitmap.Width := ClientWidth;
  FBitmap.Height := ClientHeight;
  FBitmap.Canvas.StretchDraw(ClientRect, FPicture.Bitmap);
end;

end.

